import java.util.NoSuchElementException;
import java.util.Random;

public class BinomialHeapTestClass {

	public static void main(String[] args) {
		testInsert();
		testDeleteMin();
		testDecreaseKey();
		testDelete();
		testAdditional();
	}

	private static void testAdditional() {
		System.out.println("AdditionalTests");
		boolean testE = true;
		BinomialHeap heap = new BinomialHeap();
		BinHeapNode node = heap.insert(9);
		node = heap.insert(2);
		node = heap.insert(1);
		node = heap.insert(0);
		node = heap.insert(10);
		node = heap.insert(7);
		node = heap.insert(6);
		if (!heap.toString().equals("[(6)] [(7)[(10)]] [(0)[(1)][(2)[(9)]]] ")) {
		    testE=false;
		    System.out.println("Fehler Test 1e");
		}
		node = heap.insert(4);
		node = heap.insert(3);
		node = heap.insert(15);
		node = heap.insert(17);
		node = heap.insert(5);
		node = heap.insert(27);
		node = heap.insert(18);
		node = heap.insert(20);
		if (!heap.toString().equals("[(20)] [(18)[(27)]] [(3)[(15)][(5)[(17)]]] [(0)[(1)][(2)[(9)]][(4)[(6)][(7)[(10)]]]] ")) {
		    testE=false;
		    System.out.println("Fehler Test 2e");
		}
		heap.deleteMin();
		if (!heap.toString().equals("[(18)[(27)]] [(3)[(15)][(5)[(17)]]] [(1)[(20)][(2)[(9)]][(4)[(6)][(7)[(10)]]]] ") &&
				!heap.toString().equals("[(18)[(27)]] [(4)[(6)][(7)[(10)]]] [(1)[(20)][(2)[(9)]][(3)[(15)][(5)[(17)]]]] ") &&
				!heap.toString().equals("[(18)[(27)]] [(1)[(20)][(2)[(9)]]] [(3)[(15)][(5)[(17)]][(4)[(6)][(7)[(10)]]]] ") &&
				!heap.toString().equals("[(1)[(20)]] [(3)[(15)][(5)[(17)]]] [(2)[(9)][(18)[(27)]][(4)[(6)][(7)[(10)]]]] ") &&
				!heap.toString().equals("[(1)[(20)]] [(2)[(9)][(18)[(27)]]] [(3)[(15)][(5)[(17)]][(4)[(6)][(7)[(10)]]]] ") &&
				!heap.toString().equals("[(1)[(20)]] [(4)[(6)][(7)[(10)]]] [(2)[(9)][(18)[(27)]][(3)[(15)][(5)[(17)]]]] ") &&
				!heap.toString().equals("[(2)[(9)]] [(3)[(15)][(5)[(17)]]] [(1)[(20)][(18)[(27)]][(4)[(6)][(7)[(10)]]]] ") &&
				!heap.toString().equals("[(2)[(9)]] [(1)[(20)][(18)[(27)]]] [(3)[(15)][(5)[(17)]][(4)[(6)][(7)[(10)]]]] ") &&
				!heap.toString().equals("[(2)[(9)]] [(4)[(6)][(7)[(10)]]] [(1)[(20)][(18)[(27)]][(3)[(15)][(5)[(17)]]]] ")) {
		    testE=false;
		    System.out.println("Fehler Test 3e");
		}
		//ParentProblem
		heap = new BinomialHeap();
		heap.insert(2);
		node = heap.insert(4);
		heap.deleteMin();
		heap.decreaseKey(node, 1);
		if (!heap.toString().equals("[(1)] ")) {
		    testE=false;
		    System.out.println("Fehler Test 4e");
		}
		if (testE) System.out.println("OK");
		
	}

	private static void testDelete() {
		System.out.println("Test exercise 9.4)");
		boolean test = true;
		BinomialHeap heap = new BinomialHeap();
		BinHeapNode node = heap.insert(9);
		heap.insert(2);
		heap.insert(3);
		BinHeapNode node2 = heap.insert(4);
		heap.insert(7);
		heap.insert(6);
		heap.insert(14);
		
		heap.delete(node);
		heap.delete(node2);
		
		heap.insert(1);
		heap.insert(5);

		//Test 2
		if (heap.deleteMin()!=1 || heap.deleteMin()!=2 || heap.deleteMin()!=3 || heap.deleteMin()!=5 || heap.deleteMin()!=6 || heap.deleteMin()!=7 || heap.deleteMin()!=14) {
			test = false;
			System.out.println("Fehler Test 1d");
		}
		if (test) System.out.println("OK");
	}

	private static void testDecreaseKey() {
		System.out.println("Test exercise 9.3)");	
		boolean test = true;
		BinomialHeap heap = new BinomialHeap();
		BinHeapNode node = heap.insert(42);
		heap.decreaseKey(node, 10);
		if (heap.deleteMin()!=10) {
			test = false;
			System.out.println("Fehler Test 1c");
		}
		node = heap.insert(42);
		boolean errorFound = false;
		try {
			heap.decreaseKey(node, 44);
		} catch (IllegalArgumentException e) {
			errorFound = true;
		}
		if (!errorFound) {
			System.out.println("Fehler bei increaseKey nicht gefunden");
			test = false;
		};
		
		heap = new BinomialHeap();
		BinHeapNode node3 = heap.insert(3);
		heap.insert(10);
		heap.insert(1);
		heap.insert(0);
		heap.insert(4);
		heap.insert(6);
		heap.insert(14);
		BinHeapNode node16 = heap.insert(16);
		node = heap.insert(15);
		heap.insert(8);
		heap.insert(2);
		heap.insert(5);
		BinHeapNode rNode = heap.insert(20);
		
		if (!heap.toString().equals("[(20)] [(2)[(5)][(8)[(15)]]] [(0)[(1)][(3)[(10)]][(4)[(6)][(14)[(16)]]]] ")) {
			test = false;
			System.out.println("Fehler Test 1c");
		}
		heap.decreaseKey(node, 6);
		heap.decreaseKey(node16, 3);
		heap.decreaseKey(rNode, -1);
		heap.decreaseKey(node3, 2);
		if (!heap.toString().equals("[(-1)] [(2)[(5)][(6)[(8)]]] [(0)[(1)][(2)[(10)]][(3)[(6)][(4)[(14)]]]] ")) {
			test = false;
			System.out.println("Fehler Test 2c");
		}
		
		if (test) System.out.println("OK");
	}

	private static void testDeleteMin() {
		System.out.println("Test exercise 9.2)");
		boolean testB = true;
		BinomialHeap heap = new BinomialHeap();
		heap.insert(42);
		if (heap.deleteMin()!=42) {
			testB = false;
			System.out.println("Fehler Test 1b");
		}
		
		heap.insert(3);
		heap.insert(2);
		heap.insert(3);
		heap.insert(2);
		heap.insert(1);
		heap.insert(5);
		heap.insert(6);
		heap.insert(7);
		heap.insert(10);
		heap.insert(0);
		
		//Test 2
		if (heap.deleteMin()!=0 || heap.deleteMin()!=1 || heap.deleteMin()!=2 || heap.deleteMin()!=2 || heap.deleteMin()!=3 || heap.deleteMin()!=3) {
			testB = false;
			System.out.println("Fehler Test 2b");
		}
		//Test 3
		if (!heap.toString().equals("[(5)[(10)][(6)[(7)]]] ")) {
			System.out.println("Fehler Test 2b");
			testB = false;
		};
		
		heap = new BinomialHeap();
		Random rand = new Random();
		for (int i=0; i<10000; i++) {
			heap.insert(rand.nextInt(4000));
		}
		int last = -1;
		for (int i=0; i<10000; i++) {
			int current = heap.deleteMin();
			if (current < last) {
				System.out.println("Fehler Test 3b");
				testB = false;
			}
			last = current;
		}
		
		heap = new BinomialHeap();
		heap.insert(10);
		heap.deleteMin();
		boolean errorFound = false;
		try {
			heap.deleteMin();
		} catch (NoSuchElementException e) {
			errorFound = true;
		}
		if (!errorFound) {
			System.out.println("Fehler: DeleteMin bei leeren Heaps");
			testB = false;
		};
		
		if (testB) System.out.println("OK");
	}

	private static void testInsert() {
		System.out.println("Test exercise 9.1)");
		boolean testA = true;
		BinomialHeap heap = new BinomialHeap();
		
		//Test 1
		if (!heap.toString().equals("empty heap")) {
			System.out.println("Fehler: Leerer Heap");
			testA = false;
		};
		
		heap.insert(0);
		
		//Test 2
		if (!heap.toString().equals("[(0)] ")) {
			System.out.println("Fehler Test 2a");
			testA = false;
		};
		
		heap.insert(0);
		heap.insert(1);
		heap.insert(2);
		
		//Test 3
		if (!heap.toString().equals("[(0)[(0)][(1)[(2)]]] ")) {
			System.out.println("Fehler Test 3a");
			testA = false;
		};
		
		heap.insert(3);
		heap.insert(4);
		heap.insert(5);
		heap.insert(6);
		heap.insert(0);
		
		//Test 4
		if (!heap.toString().equals("[(0)] [(0)[(0)][(1)[(2)]][(3)[(4)][(5)[(6)]]]] ")) {
			System.out.println("Fehler Test 4a");
			testA = false;
		};
		
		heap.insert(0);
		heap.insert(1);
		heap.insert(2);
		heap.insert(3);
		heap.insert(4);
		heap.insert(5);
		heap.insert(6);
		
		
		//Test 5
		if (!heap.toString().equals("[(0)[(0)][(1)[(2)]][(3)[(4)][(5)[(6)]]][(0)[(0)][(1)[(2)]][(3)[(4)][(5)[(6)]]]]] ")) {
			System.out.println("Fehler Test 5a");
			testA = false;
		};
		
		if (testA) System.out.println("OK");
	}

}
